/* Standard Header File for SimCell Regulation      |
|                  2007.11.01 Arch Lab. TOKYO TECH */

/* header file system part.                        */
/*-------------------------------------------------*/

#ifndef _DEFINE_H_
#define _DEFINE_H_
#ifdef _GLOBAL_
#define EXTERN
#else /* _GLOBAL_ */
#define EXTERN extern
#endif /* _GLOBAL_ */

#ifdef _PPESOURCE_
#include <stdio.h>
#include <stdlib.h>
#include <libspe2.h>
#include <pthread.h>
#endif /* _PPESOURCE_ */

#ifdef _SPESOURCE_
#include <spu_intrinsics.h>
#include <spu_mfcio.h>
#include <stdio.h>
#endif /* _SPESOURCE_ */

#include "user.h"

#define SPE_FILE_NAME "./spe_main"

#define DMA_TAG0 0
#define DMA_TAG1 1
#define DMA_TAG2 2
#define DMA_TAG3 3
#define DMA_TAG4 4

#define MASK_32T 0xffffffff
typedef unsigned int uint;
typedef unsigned long long uint64;

typedef struct { // 128B 
    int spe_num;    // the number of spe
    int spe_id;     // the identifier of spe
    int ppe2spe[15]; // data from ppe to spe
    int spe2ppe[15]; // data from spe to ppe
} __attribute__ ((aligned(128))) dmapack_t;

#ifdef _PPESOURCE_
EXTERN volatile dmapack_t dmapack[SPE_NUM] __attribute__ ((aligned(128)));
#endif /* _PPESOURCE_ */
#ifdef _SPESOURCE_
void spe_initialize();
EXTERN int ea_dmapack;
EXTERN volatile dmapack_t dmapack __attribute__ ((aligned(128)));
#endif /* _SPESOURCE_ */

#endif /* _DEFINE_H_ */
