#include "define.h"

#ifdef _PPESOURCE_

void initialize(spe_context_ptr_t *spe)
{
    int i;

    for (i = 0; i < SPE_NUM; i++) {
        dmapack[i].spe_num = SPE_NUM;
        dmapack[i].spe_id  = i + 1;
        /* set ppe2spe[] */
    }

#ifdef MEMIMAGE
    int *p;
    FILE *fp;
    if ((fp = fopen(MEMIMAGE, "wb")) == NULL) {
        fprintf(stderr, "file can't open.\n");
        return;
    }
    fprintf(fp, "SimCell_PPE_MEMORY_IMAGE_FILE_VERSION_1.0\n");
    
    p = (int *)dmapack;
    for (i = 0; i < sizeof(dmapack) / 4; i++)
        fprintf(fp, "@mem %08x %08x\n", (uint) dmapack + 4 * i, p[i]);

    for (i = 0; i < SPE_NUM; i++)
        fprintf(fp, "@mal %08x %08x\n", i + 1, (uint) &dmapack[i]);
    
    fprintf(fp, "@end %08x %08x\n", 0, 0);
    fclose(fp);
#endif /* MEMIMAGE */
}

void finalize()
{
    int i;

    for (i = 0; i < SPE_NUM; i++)
        printf("spe #%d: spe2ppe[0] = %d\n",
               i + 1, dmapack[i].spe2ppe[0]);
}

#endif /* _PPESOURCE_ */

/**********************************************************************/

#ifdef _SPESOURCE_

inline void wait_dma(int dma_tag)
{
    spu_writech(MFC_WrTagMask, 1 << dma_tag);
    spu_mfcstat(MFC_TAG_UPDATE_ALL);
}

int main()
{
    spe_initialize();

    dmapack.spe2ppe[0] = dmapack.spe_id * dmapack.spe_id;
    mfc_put(&dmapack, ea_dmapack, sizeof(dmapack), DMA_TAG0, 0, 0);
    wait_dma(DMA_TAG0);
            
    return 0;
}

#endif /* _SPESOURCE_ */
