#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

typedef struct tagBITMAPFILEHEADER {
    unsigned short bfType;
    unsigned int   bfSize __attribute__((packed));
    unsigned short bfReserved1;
    unsigned short bfReserved2;
    unsigned int   bfOffBits __attribute__((packed));
} BITMAPFILEHEADER ;

typedef struct tagBITMAPINFOHEADER {
    unsigned int   biSize;
    int            biWidth;
    int            biHeight;
    unsigned short biPlanes;
    unsigned short biBitCount;
    unsigned int   biCompression;
    unsigned int   biSizeImage;
    int            biXPixPerMeter;
    int            biYPixPerMeter;
    unsigned int   biClrUsed;
    unsigned int   biClrImportant;
} BITMAPINFOHEADER;

typedef struct _RGB_32 {
    char B;
    char G;
    char R;
    char reserved;
} RGB_32;

typedef union _Pixel {
    unsigned int color;
    RGB_32 RGB;
} Pixel;

enum ENDIAN_STATE {
    UNKNOWN,
    BIG,
    LITTLE
};

enum ENDIAN_STATE ENDIAN;

#define BFTYPE_BM 0x4d42

#define align_4b(x) ((x) + (((x) % 4) ? (4 - ((x) % 4)) : 0))
#define getpixel(img, x, y, width) ((img) + ((x) + (y) * (width)))

int bmpgen(char *, Pixel *, int, int);
