/* mand .. Mandelbrot set program for Cell BE       |
|   2007.10.24 Naoki FUJIEDA, Arch Lab. TOKYO TECH */

/* user application part.                          */
/*-------------------------------------------------*/

#define SPE_NUM 6
#define MEMIMAGE "mem_mand.txt"
#define DMA_ALIGN 128
#define DMA_SIZE_MAX 0x4000

#define PIC_WIDTH 400
#define PIC_HEIGHT 300
#define PIC_NUM (PIC_WIDTH * PIC_HEIGHT)
#define BLOCK_NUM 2400
#define TOTAL_BLOCK (PIC_NUM / BLOCK_NUM)

#define MAX_CALC 4096

typedef struct {
    float left;
    float top;
    float width;
    float height;
} rect_t;

typedef struct {
    int spe_num;
    int spe_id;
    int ea_pic;
    rect_t rc;
    int reserved[25];
} __attribute__ ((aligned(128))) mand_t;

#ifdef _PPESOURCE_
#include "bmpgen.h"

EXTERN volatile Pixel pict_data[PIC_NUM] __attribute__ ((aligned(128)));
#endif /* _PPESOURCE_ */

#ifdef _SPESOURCE_
EXTERN volatile mand_t *mand;
EXTERN volatile uint mem[BLOCK_NUM] __attribute__ ((aligned(DMA_ALIGN)));
EXTERN uint ea_pic;

typedef vector unsigned int v_uint;
typedef vector float v_float;

#define int2vfloat(num) (spu_splats((float)(num)))
#endif /* _SPESOURCE_ */
